<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>/home/tylerwbrown/Code/Personal/magical-joe-haskell/src/Fib.hs</title>
</head>
<head>
<link type='text/css' rel='stylesheet' href='liquid.css' />
</head>

<body>
<hr>
Put mouse over identifiers to see inferred types
<pre><span class=hs-linenum> 1: </span><a class=annot href="#"><span class=annottext>GHC.Types.Module</span><span class='hs-keyword'>module</span></a> <span class='hs-conid'>Fib</span> <span class='hs-keyword'>where</span>
<span class=hs-linenum> 2: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>General</span>
<span class=hs-linenum> 3: </span>
<span class=hs-linenum> 4: </span><span class='hs-comment'>-- fib :: Int -&gt; [Int]</span>
<span class=hs-linenum> 5: </span><span class='hs-comment'>-- fib n = take n $ seq 0 1</span>
<span class=hs-linenum> 6: </span><span class='hs-comment'>--  where seq a b = a : seq b (a + b)</span>
<span class=hs-linenum> 7: </span><span class=hs-error><a class=annot href="#"><span class=annottext>[GHC.Integer.Type.Integer]</span><span class='hs-definition'>fib</span></a></span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>[GHC.Integer.Type.Integer]</span><span class='hs-keyglyph'>[</span></a><span class='hs-num'>0</span><span class='hs-layout'>,</span> <span class='hs-num'>1</span><span class='hs-keyglyph'>]</span> <span class='hs-varop'>++</span> <a class=annot href="#"><span class=annottext>x1:GHC.Integer.Type.Integer -&gt; x2:GHC.Integer.Type.Integer -&gt; {v : GHC.Integer.Type.Integer | v == x1 + x2}</span><span class='hs-varid'>zipWith</span></a> <span class='hs-layout'>(</span><span class='hs-varop'>+</span><span class='hs-layout'>)</span> <span class='hs-varid'>fib</span> <span class='hs-layout'>(</span><span class=hs-error><a class=annot href="#"><span class=annottext>{v : [GHC.Integer.Type.Integer] | len v == len Fib.fib - 1
                                  &amp;&amp; v == tail Fib.fib}</span><span class='hs-varid'>tail</span></a></span><span class=hs-error> </span><span class=hs-error><span class='hs-varid'>fib</span></span><span class='hs-layout'>)</span>
<span class=hs-linenum> 8: </span>
<span class=hs-linenum> 9: </span>
<span class=hs-linenum>10: </span><span class='hs-definition'>add</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>Int</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-conid'>Int</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-conid'>Int</span>
<span class=hs-linenum>11: </span><a class=annot href="#"><span class=annottext>GHC.Types.Int -&gt; GHC.Types.Int -&gt; GHC.Types.Int</span><span class='hs-definition'>add</span></a> <a class=annot href="#"><span class=annottext>GHC.Types.Int</span><span class='hs-varid'>x</span></a> <span class='hs-num'>7</span> <span class='hs-keyglyph'>=</span> <span class='hs-num'>17</span>
<span class=hs-linenum>12: </span><span class='hs-definition'>add</span> <span class='hs-num'>0</span> <span class='hs-sel'>_y</span> <span class='hs-keyglyph'>=</span> <span class='hs-num'>24</span>
<span class=hs-linenum>13: </span><span class='hs-definition'>add</span> <span class='hs-varid'>x</span> <span class='hs-varid'>y</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>GHC.Types.Int</span><span class='hs-varid'>x</span></a> <a class=annot href="#"><span class=annottext>x1:GHC.Types.Int -&gt; x2:GHC.Types.Int -&gt; {v : GHC.Types.Int | v == x1 + x2}</span><span class='hs-varop'>+</span></a> <span class='hs-varid'>y</span>
<span class=hs-linenum>14: </span>
</pre>
</body>
</html>